// A Bison parser, made by GNU Bison 3.7.6.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.



// First part of user prologue.
#line 1 "parse/thrifty.yy"

/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements. See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership. The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License. You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

/**
 * Thrift parser.
 *
 * This parser is used on a thrift definition file.
 *
 */

#define __STDC_LIMIT_MACROS
#define __STDC_FORMAT_MACROS

#include <cassert>
#include <stdio.h>
#include <inttypes.h>
#include <limits.h>
#include <stack>
#include <utility>

#include <boost/optional.hpp>

#include <thrift/compiler/ast/t_scope.h>
#include <thrift/compiler/ast/t_union.h>
#include <thrift/compiler/parse/parsing_driver.h>
#include <thrift/compiler/ast/t_container.h>

/**
 * Note macro expansion because this is different between OSS and internal
 * build, sigh.
 */
#include THRIFTY_HH

/**
 * Declare fbthrift_compiler_parse_lex() so we can use it.
 */
YY_DECL;
#define yylex fbthrift_compiler_parse_lex

namespace apache {
namespace thrift {
namespace compiler {
namespace {

// Assume ownership of a pointer.
template <typename T>
std::unique_ptr<T> own(T* ptr) {
  return std::unique_ptr<T>(ptr);
}

} // namespace
} // namespace compiler
} // namespace thrift
} // namespace apache


#line 115 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"


#include "thrifty.hh"




#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

#line 95 "parse/thrifty.yy"
namespace apache { namespace thrift { namespace compiler { namespace yy {
#line 213 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"

  /// Build a parser object.
  parser::parser (apache::thrift::compiler::parsing_driver& driver_yyarg, apache::thrift::compiler::yyscan_t raw_scanner_yyarg, YYSTYPE * yylval_param_yyarg, YYLTYPE * yylloc_param_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      raw_scanner (raw_scanner_yyarg),
      yylval_param (yylval_param_yyarg),
      yylloc_param (yylloc_param_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/



  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.YY_MOVE_OR_COPY< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldId: // FieldId
        value.YY_MOVE_OR_COPY< boost::optional<t_field_id> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
      case symbol_kind::S_Double: // Double
        value.YY_MOVE_OR_COPY< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Integer: // Integer
        value.YY_MOVE_OR_COPY< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionType: // FunctionType
        value.YY_MOVE_OR_COPY< std::pair<t_type_ref, boost::optional<t_type_ref>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_FieldTypeIdentifier: // FieldTypeIdentifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Annotation: // Annotation
        value.YY_MOVE_OR_COPY< t_annotation* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Annotations: // Annotations
      case symbol_kind::S_AnnotationList: // AnnotationList
        value.YY_MOVE_OR_COPY< t_annotations* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.YY_MOVE_OR_COPY< t_const* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.YY_MOVE_OR_COPY< t_const_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.YY_MOVE_OR_COPY< t_container* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_StatementAttrs: // StatementAttrs
        value.YY_MOVE_OR_COPY< t_def_attrs* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_tok_inline_doc: // tok_inline_doc
      case symbol_kind::S_CaptureDocText: // CaptureDocText
      case symbol_kind::S_InlineDocOptional: // InlineDocOptional
        value.YY_MOVE_OR_COPY< t_doc > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Enum: // Enum
        value.YY_MOVE_OR_COPY< t_enum* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_EnumValueAnnotated: // EnumValueAnnotated
      case symbol_kind::S_EnumValue: // EnumValue
        value.YY_MOVE_OR_COPY< t_enum_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_EnumValueList: // EnumValueList
        value.YY_MOVE_OR_COPY< t_enum_value_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        value.YY_MOVE_OR_COPY< t_error_blame > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        value.YY_MOVE_OR_COPY< t_error_kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        value.YY_MOVE_OR_COPY< t_error_safety > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Exception: // Exception
        value.YY_MOVE_OR_COPY< t_exception* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Field: // Field
      case symbol_kind::S_FieldAnnotated: // FieldAnnotated
        value.YY_MOVE_OR_COPY< t_field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldList: // FieldList
        value.YY_MOVE_OR_COPY< t_field_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldQualifier: // FieldQualifier
        value.YY_MOVE_OR_COPY< t_field_qualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Function: // Function
      case symbol_kind::S_FunctionAnnotated: // FunctionAnnotated
      case symbol_kind::S_Performs: // Performs
        value.YY_MOVE_OR_COPY< t_function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        value.YY_MOVE_OR_COPY< t_function_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.YY_MOVE_OR_COPY< t_function_qualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Interaction: // Interaction
        value.YY_MOVE_OR_COPY< t_interaction* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Header: // Header
      case symbol_kind::S_Definition: // Definition
      case symbol_kind::S_Statement: // Statement
      case symbol_kind::S_StatementAnnotated: // StatementAnnotated
        value.YY_MOVE_OR_COPY< t_named* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BaseType: // BaseType
        value.YY_MOVE_OR_COPY< t_ref<t_base_type> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Extends: // Extends
        value.YY_MOVE_OR_COPY< t_ref<t_service> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Service: // Service
        value.YY_MOVE_OR_COPY< t_service* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.YY_MOVE_OR_COPY< t_sink* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.YY_MOVE_OR_COPY< t_stream_response* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Struct: // Struct
        value.YY_MOVE_OR_COPY< t_struct* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        value.YY_MOVE_OR_COPY< t_struct_annotations* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_MaybeThrows: // MaybeThrows
        value.YY_MOVE_OR_COPY< t_throws* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FieldType: // FieldType
        value.YY_MOVE_OR_COPY< t_type_ref > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.YY_MOVE_OR_COPY< t_typedef* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.YY_MOVE_OR_COPY< t_typethrowspair > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Union: // Union
        value.YY_MOVE_OR_COPY< t_union* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_int_constant: // tok_int_constant
        value.YY_MOVE_OR_COPY< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.move< bool > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldId: // FieldId
        value.move< boost::optional<t_field_id> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
      case symbol_kind::S_Double: // Double
        value.move< double > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Integer: // Integer
        value.move< int64_t > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionType: // FunctionType
        value.move< std::pair<t_type_ref, boost::optional<t_type_ref>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_FieldTypeIdentifier: // FieldTypeIdentifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.move< std::string > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Annotation: // Annotation
        value.move< t_annotation* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Annotations: // Annotations
      case symbol_kind::S_AnnotationList: // AnnotationList
        value.move< t_annotations* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.move< t_const* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.move< t_const_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.move< t_container* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_StatementAttrs: // StatementAttrs
        value.move< t_def_attrs* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_tok_inline_doc: // tok_inline_doc
      case symbol_kind::S_CaptureDocText: // CaptureDocText
      case symbol_kind::S_InlineDocOptional: // InlineDocOptional
        value.move< t_doc > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Enum: // Enum
        value.move< t_enum* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_EnumValueAnnotated: // EnumValueAnnotated
      case symbol_kind::S_EnumValue: // EnumValue
        value.move< t_enum_value* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_EnumValueList: // EnumValueList
        value.move< t_enum_value_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        value.move< t_error_blame > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        value.move< t_error_kind > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        value.move< t_error_safety > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Exception: // Exception
        value.move< t_exception* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Field: // Field
      case symbol_kind::S_FieldAnnotated: // FieldAnnotated
        value.move< t_field* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldList: // FieldList
        value.move< t_field_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FieldQualifier: // FieldQualifier
        value.move< t_field_qualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Function: // Function
      case symbol_kind::S_FunctionAnnotated: // FunctionAnnotated
      case symbol_kind::S_Performs: // Performs
        value.move< t_function* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        value.move< t_function_list* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.move< t_function_qualifier > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Interaction: // Interaction
        value.move< t_interaction* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Header: // Header
      case symbol_kind::S_Definition: // Definition
      case symbol_kind::S_Statement: // Statement
      case symbol_kind::S_StatementAnnotated: // StatementAnnotated
        value.move< t_named* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_BaseType: // BaseType
        value.move< t_ref<t_base_type> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Extends: // Extends
        value.move< t_ref<t_service> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Service: // Service
        value.move< t_service* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.move< t_sink* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.move< t_stream_response* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Struct: // Struct
        value.move< t_struct* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        value.move< t_struct_annotations* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_MaybeThrows: // MaybeThrows
        value.move< t_throws* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FieldType: // FieldType
        value.move< t_type_ref > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.move< t_typedef* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.move< t_typethrowspair > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_Union: // Union
        value.move< t_union* > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_tok_int_constant: // tok_int_constant
        value.move< uint64_t > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.copy< bool > (that.value);
        break;

      case symbol_kind::S_FieldId: // FieldId
        value.copy< boost::optional<t_field_id> > (that.value);
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
      case symbol_kind::S_Double: // Double
        value.copy< double > (that.value);
        break;

      case symbol_kind::S_Integer: // Integer
        value.copy< int64_t > (that.value);
        break;

      case symbol_kind::S_FunctionType: // FunctionType
        value.copy< std::pair<t_type_ref, boost::optional<t_type_ref>> > (that.value);
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_FieldTypeIdentifier: // FieldTypeIdentifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.copy< std::string > (that.value);
        break;

      case symbol_kind::S_Annotation: // Annotation
        value.copy< t_annotation* > (that.value);
        break;

      case symbol_kind::S_Annotations: // Annotations
      case symbol_kind::S_AnnotationList: // AnnotationList
        value.copy< t_annotations* > (that.value);
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.copy< t_const* > (that.value);
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.copy< t_const_value* > (that.value);
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.copy< t_container* > (that.value);
        break;

      case symbol_kind::S_StatementAttrs: // StatementAttrs
        value.copy< t_def_attrs* > (that.value);
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_tok_inline_doc: // tok_inline_doc
      case symbol_kind::S_CaptureDocText: // CaptureDocText
      case symbol_kind::S_InlineDocOptional: // InlineDocOptional
        value.copy< t_doc > (that.value);
        break;

      case symbol_kind::S_Enum: // Enum
        value.copy< t_enum* > (that.value);
        break;

      case symbol_kind::S_EnumValueAnnotated: // EnumValueAnnotated
      case symbol_kind::S_EnumValue: // EnumValue
        value.copy< t_enum_value* > (that.value);
        break;

      case symbol_kind::S_EnumValueList: // EnumValueList
        value.copy< t_enum_value_list* > (that.value);
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        value.copy< t_error_blame > (that.value);
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        value.copy< t_error_kind > (that.value);
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        value.copy< t_error_safety > (that.value);
        break;

      case symbol_kind::S_Exception: // Exception
        value.copy< t_exception* > (that.value);
        break;

      case symbol_kind::S_Field: // Field
      case symbol_kind::S_FieldAnnotated: // FieldAnnotated
        value.copy< t_field* > (that.value);
        break;

      case symbol_kind::S_FieldList: // FieldList
        value.copy< t_field_list* > (that.value);
        break;

      case symbol_kind::S_FieldQualifier: // FieldQualifier
        value.copy< t_field_qualifier > (that.value);
        break;

      case symbol_kind::S_Function: // Function
      case symbol_kind::S_FunctionAnnotated: // FunctionAnnotated
      case symbol_kind::S_Performs: // Performs
        value.copy< t_function* > (that.value);
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        value.copy< t_function_list* > (that.value);
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.copy< t_function_qualifier > (that.value);
        break;

      case symbol_kind::S_Interaction: // Interaction
        value.copy< t_interaction* > (that.value);
        break;

      case symbol_kind::S_Header: // Header
      case symbol_kind::S_Definition: // Definition
      case symbol_kind::S_Statement: // Statement
      case symbol_kind::S_StatementAnnotated: // StatementAnnotated
        value.copy< t_named* > (that.value);
        break;

      case symbol_kind::S_BaseType: // BaseType
        value.copy< t_ref<t_base_type> > (that.value);
        break;

      case symbol_kind::S_Extends: // Extends
        value.copy< t_ref<t_service> > (that.value);
        break;

      case symbol_kind::S_Service: // Service
        value.copy< t_service* > (that.value);
        break;

      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.copy< t_sink* > (that.value);
        break;

      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.copy< t_stream_response* > (that.value);
        break;

      case symbol_kind::S_Struct: // Struct
        value.copy< t_struct* > (that.value);
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        value.copy< t_struct_annotations* > (that.value);
        break;

      case symbol_kind::S_MaybeThrows: // MaybeThrows
        value.copy< t_throws* > (that.value);
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FieldType: // FieldType
        value.copy< t_type_ref > (that.value);
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.copy< t_typedef* > (that.value);
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.copy< t_typethrowspair > (that.value);
        break;

      case symbol_kind::S_Union: // Union
        value.copy< t_union* > (that.value);
        break;

      case symbol_kind::S_tok_int_constant: // tok_int_constant
        value.copy< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        value.move< bool > (that.value);
        break;

      case symbol_kind::S_FieldId: // FieldId
        value.move< boost::optional<t_field_id> > (that.value);
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
      case symbol_kind::S_Double: // Double
        value.move< double > (that.value);
        break;

      case symbol_kind::S_Integer: // Integer
        value.move< int64_t > (that.value);
        break;

      case symbol_kind::S_FunctionType: // FunctionType
        value.move< std::pair<t_type_ref, boost::optional<t_type_ref>> > (that.value);
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_FieldTypeIdentifier: // FieldTypeIdentifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        value.move< std::string > (that.value);
        break;

      case symbol_kind::S_Annotation: // Annotation
        value.move< t_annotation* > (that.value);
        break;

      case symbol_kind::S_Annotations: // Annotations
      case symbol_kind::S_AnnotationList: // AnnotationList
        value.move< t_annotations* > (that.value);
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        value.move< t_const* > (that.value);
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        value.move< t_const_value* > (that.value);
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        value.move< t_container* > (that.value);
        break;

      case symbol_kind::S_StatementAttrs: // StatementAttrs
        value.move< t_def_attrs* > (that.value);
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_tok_inline_doc: // tok_inline_doc
      case symbol_kind::S_CaptureDocText: // CaptureDocText
      case symbol_kind::S_InlineDocOptional: // InlineDocOptional
        value.move< t_doc > (that.value);
        break;

      case symbol_kind::S_Enum: // Enum
        value.move< t_enum* > (that.value);
        break;

      case symbol_kind::S_EnumValueAnnotated: // EnumValueAnnotated
      case symbol_kind::S_EnumValue: // EnumValue
        value.move< t_enum_value* > (that.value);
        break;

      case symbol_kind::S_EnumValueList: // EnumValueList
        value.move< t_enum_value_list* > (that.value);
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        value.move< t_error_blame > (that.value);
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        value.move< t_error_kind > (that.value);
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        value.move< t_error_safety > (that.value);
        break;

      case symbol_kind::S_Exception: // Exception
        value.move< t_exception* > (that.value);
        break;

      case symbol_kind::S_Field: // Field
      case symbol_kind::S_FieldAnnotated: // FieldAnnotated
        value.move< t_field* > (that.value);
        break;

      case symbol_kind::S_FieldList: // FieldList
        value.move< t_field_list* > (that.value);
        break;

      case symbol_kind::S_FieldQualifier: // FieldQualifier
        value.move< t_field_qualifier > (that.value);
        break;

      case symbol_kind::S_Function: // Function
      case symbol_kind::S_FunctionAnnotated: // FunctionAnnotated
      case symbol_kind::S_Performs: // Performs
        value.move< t_function* > (that.value);
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        value.move< t_function_list* > (that.value);
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        value.move< t_function_qualifier > (that.value);
        break;

      case symbol_kind::S_Interaction: // Interaction
        value.move< t_interaction* > (that.value);
        break;

      case symbol_kind::S_Header: // Header
      case symbol_kind::S_Definition: // Definition
      case symbol_kind::S_Statement: // Statement
      case symbol_kind::S_StatementAnnotated: // StatementAnnotated
        value.move< t_named* > (that.value);
        break;

      case symbol_kind::S_BaseType: // BaseType
        value.move< t_ref<t_base_type> > (that.value);
        break;

      case symbol_kind::S_Extends: // Extends
        value.move< t_ref<t_service> > (that.value);
        break;

      case symbol_kind::S_Service: // Service
        value.move< t_service* > (that.value);
        break;

      case symbol_kind::S_SinkReturnType: // SinkReturnType
        value.move< t_sink* > (that.value);
        break;

      case symbol_kind::S_StreamReturnType: // StreamReturnType
        value.move< t_stream_response* > (that.value);
        break;

      case symbol_kind::S_Struct: // Struct
        value.move< t_struct* > (that.value);
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        value.move< t_struct_annotations* > (that.value);
        break;

      case symbol_kind::S_MaybeThrows: // MaybeThrows
        value.move< t_throws* > (that.value);
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FieldType: // FieldType
        value.move< t_type_ref > (that.value);
        break;

      case symbol_kind::S_Typedef: // Typedef
        value.move< t_typedef* > (that.value);
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        value.move< t_typethrowspair > (that.value);
        break;

      case symbol_kind::S_Union: // Union
        value.move< t_union* > (that.value);
        break;

      case symbol_kind::S_tok_int_constant: // tok_int_constant
        value.move< uint64_t > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, raw_scanner, yylval_param, yylloc_param));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_tok_bool_constant: // tok_bool_constant
      case symbol_kind::S_CommaOrSemicolonOptional: // CommaOrSemicolonOptional
        yylhs.value.emplace< bool > ();
        break;

      case symbol_kind::S_FieldId: // FieldId
        yylhs.value.emplace< boost::optional<t_field_id> > ();
        break;

      case symbol_kind::S_tok_dub_constant: // tok_dub_constant
      case symbol_kind::S_Double: // Double
        yylhs.value.emplace< double > ();
        break;

      case symbol_kind::S_Integer: // Integer
        yylhs.value.emplace< int64_t > ();
        break;

      case symbol_kind::S_FunctionType: // FunctionType
        yylhs.value.emplace< std::pair<t_type_ref, boost::optional<t_type_ref>> > ();
        break;

      case symbol_kind::S_tok_identifier: // tok_identifier
      case symbol_kind::S_tok_literal: // tok_literal
      case symbol_kind::S_FieldTypeIdentifier: // FieldTypeIdentifier
      case symbol_kind::S_Identifier: // Identifier
      case symbol_kind::S_IntOrLiteral: // IntOrLiteral
        yylhs.value.emplace< std::string > ();
        break;

      case symbol_kind::S_Annotation: // Annotation
        yylhs.value.emplace< t_annotation* > ();
        break;

      case symbol_kind::S_Annotations: // Annotations
      case symbol_kind::S_AnnotationList: // AnnotationList
        yylhs.value.emplace< t_annotations* > ();
        break;

      case symbol_kind::S_Const: // Const
      case symbol_kind::S_StructuredAnnotation: // StructuredAnnotation
        yylhs.value.emplace< t_const* > ();
        break;

      case symbol_kind::S_ConstValue: // ConstValue
      case symbol_kind::S_ConstList: // ConstList
      case symbol_kind::S_ConstListContents: // ConstListContents
      case symbol_kind::S_ConstMap: // ConstMap
      case symbol_kind::S_ConstMapContents: // ConstMapContents
      case symbol_kind::S_ConstStruct: // ConstStruct
      case symbol_kind::S_ConstStructContents: // ConstStructContents
      case symbol_kind::S_FieldValue: // FieldValue
        yylhs.value.emplace< t_const_value* > ();
        break;

      case symbol_kind::S_ContainerType: // ContainerType
      case symbol_kind::S_MapType: // MapType
      case symbol_kind::S_SetType: // SetType
      case symbol_kind::S_ListType: // ListType
        yylhs.value.emplace< t_container* > ();
        break;

      case symbol_kind::S_StatementAttrs: // StatementAttrs
        yylhs.value.emplace< t_def_attrs* > ();
        break;

      case symbol_kind::S_tok_doctext: // tok_doctext
      case symbol_kind::S_tok_inline_doc: // tok_inline_doc
      case symbol_kind::S_CaptureDocText: // CaptureDocText
      case symbol_kind::S_InlineDocOptional: // InlineDocOptional
        yylhs.value.emplace< t_doc > ();
        break;

      case symbol_kind::S_Enum: // Enum
        yylhs.value.emplace< t_enum* > ();
        break;

      case symbol_kind::S_EnumValueAnnotated: // EnumValueAnnotated
      case symbol_kind::S_EnumValue: // EnumValue
        yylhs.value.emplace< t_enum_value* > ();
        break;

      case symbol_kind::S_EnumValueList: // EnumValueList
        yylhs.value.emplace< t_enum_value_list* > ();
        break;

      case symbol_kind::S_ErrorBlame: // ErrorBlame
        yylhs.value.emplace< t_error_blame > ();
        break;

      case symbol_kind::S_ErrorKind: // ErrorKind
        yylhs.value.emplace< t_error_kind > ();
        break;

      case symbol_kind::S_ErrorSafety: // ErrorSafety
        yylhs.value.emplace< t_error_safety > ();
        break;

      case symbol_kind::S_Exception: // Exception
        yylhs.value.emplace< t_exception* > ();
        break;

      case symbol_kind::S_Field: // Field
      case symbol_kind::S_FieldAnnotated: // FieldAnnotated
        yylhs.value.emplace< t_field* > ();
        break;

      case symbol_kind::S_FieldList: // FieldList
        yylhs.value.emplace< t_field_list* > ();
        break;

      case symbol_kind::S_FieldQualifier: // FieldQualifier
        yylhs.value.emplace< t_field_qualifier > ();
        break;

      case symbol_kind::S_Function: // Function
      case symbol_kind::S_FunctionAnnotated: // FunctionAnnotated
      case symbol_kind::S_Performs: // Performs
        yylhs.value.emplace< t_function* > ();
        break;

      case symbol_kind::S_FunctionList: // FunctionList
        yylhs.value.emplace< t_function_list* > ();
        break;

      case symbol_kind::S_FunctionQualifier: // FunctionQualifier
        yylhs.value.emplace< t_function_qualifier > ();
        break;

      case symbol_kind::S_Interaction: // Interaction
        yylhs.value.emplace< t_interaction* > ();
        break;

      case symbol_kind::S_Header: // Header
      case symbol_kind::S_Definition: // Definition
      case symbol_kind::S_Statement: // Statement
      case symbol_kind::S_StatementAnnotated: // StatementAnnotated
        yylhs.value.emplace< t_named* > ();
        break;

      case symbol_kind::S_BaseType: // BaseType
        yylhs.value.emplace< t_ref<t_base_type> > ();
        break;

      case symbol_kind::S_Extends: // Extends
        yylhs.value.emplace< t_ref<t_service> > ();
        break;

      case symbol_kind::S_Service: // Service
        yylhs.value.emplace< t_service* > ();
        break;

      case symbol_kind::S_SinkReturnType: // SinkReturnType
        yylhs.value.emplace< t_sink* > ();
        break;

      case symbol_kind::S_StreamReturnType: // StreamReturnType
        yylhs.value.emplace< t_stream_response* > ();
        break;

      case symbol_kind::S_Struct: // Struct
        yylhs.value.emplace< t_struct* > ();
        break;

      case symbol_kind::S_StructuredAnnotations: // StructuredAnnotations
      case symbol_kind::S_NonEmptyStructuredAnnotationList: // NonEmptyStructuredAnnotationList
        yylhs.value.emplace< t_struct_annotations* > ();
        break;

      case symbol_kind::S_MaybeThrows: // MaybeThrows
        yylhs.value.emplace< t_throws* > ();
        break;

      case symbol_kind::S_ConstStructType: // ConstStructType
      case symbol_kind::S_FieldType: // FieldType
        yylhs.value.emplace< t_type_ref > ();
        break;

      case symbol_kind::S_Typedef: // Typedef
        yylhs.value.emplace< t_typedef* > ();
        break;

      case symbol_kind::S_SinkFieldType: // SinkFieldType
        yylhs.value.emplace< t_typethrowspair > ();
        break;

      case symbol_kind::S_Union: // Union
        yylhs.value.emplace< t_union* > ();
        break;

      case symbol_kind::S_tok_int_constant: // tok_int_constant
        yylhs.value.emplace< uint64_t > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // Program: StatementList
#line 306 "parse/thrifty.yy"
    {
      driver.debug("Program -> StatementList");
      driver.clear_doctext();
    }
#line 1583 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 3: // FieldTypeIdentifier: tok_identifier
#line 320 "parse/thrifty.yy"
                 { yylhs.value.as < std::string > () = std::move(yystack_[0].value.as < std::string > ()); }
#line 1589 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 4: // Identifier: FieldTypeIdentifier
#line 323 "parse/thrifty.yy"
                      { yylhs.value.as < std::string > () = std::move(yystack_[0].value.as < std::string > ()); }
#line 1595 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 5: // Identifier: tok_package
#line 325 "parse/thrifty.yy"
                 { yylhs.value.as < std::string > () = "package"; }
#line 1601 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 6: // Identifier: tok_sink
#line 326 "parse/thrifty.yy"
                 { yylhs.value.as < std::string > () = "sink"; }
#line 1607 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 7: // Identifier: tok_oneway
#line 327 "parse/thrifty.yy"
                 { yylhs.value.as < std::string > () = "oneway"; }
#line 1613 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 8: // Identifier: tok_readonly
#line 328 "parse/thrifty.yy"
                 { yylhs.value.as < std::string > () = "readonly"; }
#line 1619 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 9: // Identifier: tok_idempotent
#line 329 "parse/thrifty.yy"
                 { yylhs.value.as < std::string > () = "idempotent"; }
#line 1625 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 10: // Identifier: tok_safe
#line 330 "parse/thrifty.yy"
                 { yylhs.value.as < std::string > () = "safe"; }
#line 1631 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 11: // Identifier: tok_transient
#line 331 "parse/thrifty.yy"
                 { yylhs.value.as < std::string > () = "transient"; }
#line 1637 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 12: // Identifier: tok_stateful
#line 332 "parse/thrifty.yy"
                 { yylhs.value.as < std::string > () = "stateful"; }
#line 1643 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 13: // Identifier: tok_permanent
#line 333 "parse/thrifty.yy"
                 { yylhs.value.as < std::string > () = "permanent"; }
#line 1649 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 14: // Identifier: tok_server
#line 334 "parse/thrifty.yy"
                 { yylhs.value.as < std::string > () = "server"; }
#line 1655 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 15: // Identifier: tok_client
#line 335 "parse/thrifty.yy"
                 { yylhs.value.as < std::string > () = "client"; }
#line 1661 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 16: // CommaOrSemicolon: ","
#line 338 "parse/thrifty.yy"
      {}
#line 1667 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 17: // CommaOrSemicolon: ";"
#line 339 "parse/thrifty.yy"
      {}
#line 1673 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 18: // CommaOrSemicolonOptional: CommaOrSemicolon
#line 342 "parse/thrifty.yy"
                   { yylhs.value.as < bool > () = true; }
#line 1679 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 19: // CommaOrSemicolonOptional: %empty
#line 343 "parse/thrifty.yy"
                   { yylhs.value.as < bool > () = false; }
#line 1685 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 20: // CaptureDocText: %empty
#line 345 "parse/thrifty.yy"
                { yylhs.value.as < t_doc > () = driver.pop_doctext(); }
#line 1691 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 21: // ProgramDocText: %empty
#line 347 "parse/thrifty.yy"
                {
    /* when there is any doctext, assign it to the top level `program` */
    driver.set_doctext(*driver.program, driver.pop_doctext());
}
#line 1700 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 22: // InlineDocOptional: tok_inline_doc
#line 354 "parse/thrifty.yy"
    {
      driver.debug("Inline doc");
      yylhs.value.as < t_doc > () = std::move(yystack_[0].value.as < t_doc > ());
    }
#line 1709 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 23: // InlineDocOptional: %empty
#line 359 "parse/thrifty.yy"
  { yylhs.value.as < t_doc > () = boost::none; }
#line 1715 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 24: // Header: tok_include tok_literal
#line 363 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_include tok_literal");
      driver.add_include(std::move(yystack_[0].value.as < std::string > ()));
      yylhs.value.as < t_named* > () = nullptr;
    }
#line 1725 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 25: // Header: tok_package tok_literal
#line 369 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_package tok_literal");
      driver.set_package(std::move(yystack_[0].value.as < std::string > ()));
      yylhs.value.as < t_named* > () = nullptr;
    }
#line 1735 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 26: // Header: tok_namespace Identifier Identifier
#line 375 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_namespace Identifier Identifier");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->set_namespace(std::move(yystack_[1].value.as < std::string > ()), std::move(yystack_[0].value.as < std::string > ()));
      }
      yylhs.value.as < t_named* > () = nullptr;
    }
#line 1747 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 27: // Header: tok_namespace Identifier tok_literal
#line 383 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_namespace Identifier tok_literal");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->set_namespace(std::move(yystack_[1].value.as < std::string > ()), std::move(yystack_[0].value.as < std::string > ()));
      }
      yylhs.value.as < t_named* > () = nullptr;
    }
#line 1759 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 28: // Header: tok_cpp_include tok_literal
#line 391 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_cpp_include tok_literal");
      if (driver.mode == parsing_mode::PROGRAM) {
        driver.program->add_cpp_include(yystack_[0].value.as < std::string > ());
      }
      yylhs.value.as < t_named* > () = nullptr;
    }
#line 1771 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 29: // Header: tok_hs_include tok_literal
#line 399 "parse/thrifty.yy"
    {
      driver.debug("Header -> tok_hs_include tok_literal");
      // Do nothing. This syntax is handled by the hs compiler
      yylhs.value.as < t_named* > () = nullptr;
    }
#line 1781 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 30: // Definition: Typedef
#line 406 "parse/thrifty.yy"
              { yylhs.value.as < t_named* > () = yystack_[0].value.as < t_typedef* > (); }
#line 1787 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 31: // Definition: Enum
#line 407 "parse/thrifty.yy"
              { yylhs.value.as < t_named* > () = yystack_[0].value.as < t_enum* > (); }
#line 1793 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 32: // Definition: Const
#line 408 "parse/thrifty.yy"
              { yylhs.value.as < t_named* > () = yystack_[0].value.as < t_const* > (); }
#line 1799 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 33: // Definition: Struct
#line 409 "parse/thrifty.yy"
              { yylhs.value.as < t_named* > () = yystack_[0].value.as < t_struct* > (); }
#line 1805 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 34: // Definition: Union
#line 410 "parse/thrifty.yy"
              { yylhs.value.as < t_named* > () = yystack_[0].value.as < t_union* > (); }
#line 1811 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 35: // Definition: Exception
#line 411 "parse/thrifty.yy"
              { yylhs.value.as < t_named* > () = yystack_[0].value.as < t_exception* > (); }
#line 1817 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 36: // Definition: Service
#line 412 "parse/thrifty.yy"
              { yylhs.value.as < t_named* > () = yystack_[0].value.as < t_service* > (); }
#line 1823 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 37: // Definition: Interaction
#line 413 "parse/thrifty.yy"
              { yylhs.value.as < t_named* > () = yystack_[0].value.as < t_interaction* > (); }
#line 1829 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 38: // Statement: ProgramDocText Header
#line 417 "parse/thrifty.yy"
    {
      driver.debug("Statement -> ProgramDocText Header");
      driver.validate_header_location();
      yylhs.value.as < t_named* > () = yystack_[0].value.as < t_named* > ();
    }
#line 1839 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 39: // Statement: Definition
#line 423 "parse/thrifty.yy"
    {
      driver.debug("Statement -> Definition");
      driver.set_parsed_definition();
      yylhs.value.as < t_named* > () = yystack_[0].value.as < t_named* > ();
    }
#line 1849 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 40: // StatementAnnotated: StatementAttrs Statement Annotations
#line 431 "parse/thrifty.yy"
    {
      driver.debug("StatementAnnotated -> StatementAttrs Statement Annotations");
      if (yystack_[1].value.as < t_named* > () == nullptr) {
        driver.validate_annotations_on_null_statement(yystack_[2].value.as < t_def_attrs* > (), yystack_[0].value.as < t_annotations* > ());
        yylhs.value.as < t_named* > () = nullptr;
      } else {
        driver.avoid_tokens_loc(yylhs.location, {{yystack_[2].value.as < t_def_attrs* > () == nullptr, yystack_[1].location}}, {{yystack_[0].value.as < t_annotations* > () == nullptr, yystack_[1].location}});
        yylhs.value.as < t_named* > () = yystack_[1].value.as < t_named* > ();
        driver.set_attributes(*yylhs.value.as < t_named* > (), own(yystack_[2].value.as < t_def_attrs* > ()), own(yystack_[0].value.as < t_annotations* > ()), yylhs.location);
      }
    }
#line 1865 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 41: // StatementAttrs: CaptureDocText StructuredAnnotations
#line 445 "parse/thrifty.yy"
    {
      driver.debug("StatementAttrs -> CaptureDocText StructuredAnnotations");
      yylhs.value.as < t_def_attrs* > () = nullptr;
      if (yystack_[1].value.as < t_doc > () || yystack_[0].value.as < t_struct_annotations* > () != nullptr) {
        driver.avoid_tokens_loc(yylhs.location, {{!yystack_[1].value.as < t_doc > (), yystack_[0].location}}, {});
        yylhs.value.as < t_def_attrs* > () = new t_def_attrs{std::move(yystack_[1].value.as < t_doc > ()), own(yystack_[0].value.as < t_struct_annotations* > ())};
      }
    }
#line 1878 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 42: // StatementList: StatementList StatementAnnotated CommaOrSemicolonOptional
#line 456 "parse/thrifty.yy"
    {
      driver.debug("StatementList -> StatementList StatementAnnotated "
        "CommaOrSemicolonOptional");
      if (yystack_[1].value.as < t_named* > () != nullptr) {
        driver.add_def(own(yystack_[1].value.as < t_named* > ()));
      }
    }
#line 1890 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 43: // StatementList: %empty
#line 463 "parse/thrifty.yy"
    {
      driver.debug("StatementList -> ");
    }
#line 1898 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 44: // Integer: tok_int_constant
#line 469 "parse/thrifty.yy"
    {
      driver.debug("Integer -> tok_int_constant");
      yylhs.value.as < int64_t > () = driver.to_int(yystack_[0].value.as < uint64_t > ());
    }
#line 1907 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 45: // Integer: "+" tok_int_constant
#line 474 "parse/thrifty.yy"
    {
      driver.debug("Integer -> + tok_int_constant");
      yylhs.value.as < int64_t > () = driver.to_int(yystack_[0].value.as < uint64_t > ());
    }
#line 1916 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 46: // Integer: "-" tok_int_constant
#line 479 "parse/thrifty.yy"
    {
      driver.debug("Integer -> - tok_int_constant");
      yylhs.value.as < int64_t > () = driver.to_int(yystack_[0].value.as < uint64_t > (), true);
    }
#line 1925 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 47: // Double: tok_dub_constant
#line 486 "parse/thrifty.yy"
    {
      driver.debug("Double -> tok_dub_constant");
      yylhs.value.as < double > () = yystack_[0].value.as < double > ();
    }
#line 1934 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 48: // Double: "+" tok_dub_constant
#line 491 "parse/thrifty.yy"
    {
      driver.debug("Double -> + tok_dub_constant");
      yylhs.value.as < double > () = yystack_[0].value.as < double > ();
    }
#line 1943 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 49: // Double: "-" tok_dub_constant
#line 496 "parse/thrifty.yy"
    {
      driver.debug("Double -> - tok_dub_constant");
      yylhs.value.as < double > () = -yystack_[0].value.as < double > ();
    }
#line 1952 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 50: // Typedef: tok_typedef FieldType Identifier
#line 503 "parse/thrifty.yy"
    {
      driver.debug("TypeDef => tok_typedef FieldType Identifier");
      yylhs.value.as < t_typedef* > () = new t_typedef(driver.program, std::move(yystack_[0].value.as < std::string > ()), std::move(yystack_[1].value.as < t_type_ref > ()));
      yylhs.value.as < t_typedef* > ()->set_lineno(yystack_[0].location.end.line);
    }
#line 1962 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 51: // Enum: tok_enum Identifier "{" EnumValueList "}"
#line 511 "parse/thrifty.yy"
    {
      driver.debug("Enum => tok_enum Identifier { EnumValueList }");
      yylhs.value.as < t_enum* > () = new t_enum(driver.program, std::move(yystack_[3].value.as < std::string > ()));
      yylhs.value.as < t_enum* > ()->set_values(std::move(*own(yystack_[1].value.as < t_enum_value_list* > ())));
      yylhs.value.as < t_enum* > ()->set_lineno(yystack_[3].location.end.line);
    }
#line 1973 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 52: // EnumValueList: EnumValueList EnumValueAnnotated CommaOrSemicolonOptional InlineDocOptional
#line 520 "parse/thrifty.yy"
    {
      driver.debug("EnumValueList EnumValueAnnotated CommaOrSemicolonOptional");
      yylhs.value.as < t_enum_value_list* > () = yystack_[3].value.as < t_enum_value_list* > ();
      if (yystack_[0].value.as < t_doc > () != boost::none) {
        driver.set_doctext(*yystack_[2].value.as < t_enum_value* > (), yystack_[0].value.as < t_doc > ());
      }
      yylhs.value.as < t_enum_value_list* > ()->emplace_back(own(yystack_[2].value.as < t_enum_value* > ()));
    }
#line 1986 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 53: // EnumValueList: %empty
#line 529 "parse/thrifty.yy"
    {
      driver.debug("EnumValueList -> ");
      yylhs.value.as < t_enum_value_list* > () = new t_enum_value_list;
    }
#line 1995 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 54: // EnumValueAnnotated: StatementAttrs EnumValue Annotations
#line 536 "parse/thrifty.yy"
    {
      driver.debug("StatementAttrs EnumValue Annotations");
      driver.avoid_tokens_loc(yylhs.location, {{yystack_[2].value.as < t_def_attrs* > () == nullptr, yystack_[1].location}}, {{yystack_[0].value.as < t_annotations* > () == nullptr, yystack_[1].location}});
      yylhs.value.as < t_enum_value* > () = yystack_[1].value.as < t_enum_value* > ();
      driver.set_attributes(*yylhs.value.as < t_enum_value* > (), own(yystack_[2].value.as < t_def_attrs* > ()), own(yystack_[0].value.as < t_annotations* > ()), yylhs.location);
    }
#line 2006 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 55: // EnumValue: Identifier "=" Integer
#line 545 "parse/thrifty.yy"
    {
      driver.debug("EnumValue -> Identifier = Integer");
      yylhs.value.as < t_enum_value* > () = new t_enum_value(std::move(yystack_[2].value.as < std::string > ()));
      yylhs.value.as < t_enum_value* > ()->set_value(driver.to_enum_value(yystack_[0].value.as < int64_t > ()));
      yylhs.value.as < t_enum_value* > ()->set_lineno(yystack_[2].location.end.line);
    }
#line 2017 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 56: // EnumValue: Identifier
#line 552 "parse/thrifty.yy"
    {
      driver.debug("EnumValue -> Identifier");
      yylhs.value.as < t_enum_value* > () = new t_enum_value(std::move(yystack_[0].value.as < std::string > ()));
      yylhs.value.as < t_enum_value* > ()->set_lineno(yystack_[0].location.end.line);
    }
#line 2027 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 57: // Const: tok_const FieldType Identifier "=" ConstValue
#line 560 "parse/thrifty.yy"
    {
      driver.debug("Const => tok_const FieldType Identifier = ConstValue");
      yylhs.value.as < t_const* > () = new t_const(driver.program, std::move(yystack_[3].value.as < t_type_ref > ()), std::move(yystack_[2].value.as < std::string > ()), own(yystack_[0].value.as < t_const_value* > ()));
      yylhs.value.as < t_const* > ()->set_lineno(yystack_[2].location.end.line);
    }
#line 2037 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 58: // ConstValue: tok_bool_constant
#line 568 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_bool_constant");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_bool(yystack_[0].value.as < bool > ());
    }
#line 2047 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 59: // ConstValue: Integer
#line 574 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => Integer");
      yylhs.value.as < t_const_value* > () = driver.to_const_value(yystack_[0].value.as < int64_t > ()).release();
    }
#line 2056 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 60: // ConstValue: Double
#line 579 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => Double");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_double(yystack_[0].value.as < double > ());
    }
#line 2066 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 61: // ConstValue: tok_literal
#line 585 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => tok_literal");
      yylhs.value.as < t_const_value* > () = new t_const_value(yystack_[0].value.as < std::string > ());
    }
#line 2075 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 62: // ConstValue: Identifier
#line 590 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => Identifier");
      yylhs.value.as < t_const_value* > () = driver.copy_const_value(yystack_[0].value.as < std::string > ()).release();
    }
#line 2084 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 63: // ConstValue: ConstList
#line 595 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstList");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 2093 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 64: // ConstValue: ConstMap
#line 600 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstMap");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 2102 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 65: // ConstValue: ConstStruct
#line 605 "parse/thrifty.yy"
    {
      driver.debug("ConstValue => ConstStruct");
      yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
    }
#line 2111 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 66: // ConstList: "[" ConstListContents CommaOrSemicolonOptional "]"
#line 612 "parse/thrifty.yy"
    {
      driver.debug("ConstList => [ ConstListContents CommaOrSemicolonOptional ]");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
    }
#line 2120 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 67: // ConstList: "[" "]"
#line 617 "parse/thrifty.yy"
    {
      driver.debug("ConstList => [ ]");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_list();
    }
#line 2130 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 68: // ConstListContents: ConstListContents CommaOrSemicolon ConstValue
#line 625 "parse/thrifty.yy"
    {
      driver.debug("ConstListContents => ConstListContents CommaOrSemicolon ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_list(own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2140 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 69: // ConstListContents: ConstValue
#line 631 "parse/thrifty.yy"
    {
      driver.debug("ConstListContents => ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_list();
      yylhs.value.as < t_const_value* > ()->add_list(own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2151 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 70: // ConstMap: "{" ConstMapContents CommaOrSemicolonOptional "}"
#line 640 "parse/thrifty.yy"
    {
      driver.debug("ConstMap => { ConstMapContents CommaOrSemicolonOptional }");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
    }
#line 2160 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 71: // ConstMap: "{" "}"
#line 645 "parse/thrifty.yy"
    {
      driver.debug("ConstMap => { }");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
    }
#line 2170 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 72: // ConstMapContents: ConstMapContents CommaOrSemicolon ConstValue ":" ConstValue
#line 653 "parse/thrifty.yy"
    {
      driver.debug("ConstMapContents => ConstMapContents CommaOrSemicolon ConstValue : ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[4].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_map(own(yystack_[2].value.as < t_const_value* > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2180 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 73: // ConstMapContents: ConstValue ":" ConstValue
#line 659 "parse/thrifty.yy"
    {
      driver.debug("ConstMapContents => ConstValue : ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->add_map(own(yystack_[2].value.as < t_const_value* > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2191 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 74: // ConstStruct: ConstStructType "{" ConstStructContents CommaOrSemicolonOptional "}"
#line 668 "parse/thrifty.yy"
    {
      driver.debug("ConstStruct => ConstStructType { ConstStructContents CommaOrSemicolonOptional }");
      yylhs.value.as < t_const_value* > () = yystack_[2].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->set_ttype(yystack_[4].value.as < t_type_ref > ());
    }
#line 2201 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 75: // ConstStruct: ConstStructType "{" "}"
#line 674 "parse/thrifty.yy"
    {
      driver.debug("ConstStruct => ConstStructType { }");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->set_ttype(yystack_[2].value.as < t_type_ref > ());
    }
#line 2212 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 76: // ConstStructType: Identifier
#line 683 "parse/thrifty.yy"
    {
      driver.debug("ConstStructType -> Identifier");
      yylhs.value.as < t_type_ref > () = driver.new_type_ref(std::move(yystack_[0].value.as < std::string > ()), nullptr, /*is_const=*/true);
    }
#line 2221 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 77: // ConstStructContents: ConstStructContents CommaOrSemicolon Identifier "=" ConstValue
#line 690 "parse/thrifty.yy"
    {
      driver.debug("ConstStructContents => ConstStructContents CommaOrSemicolon Identifier = ConstValue");
      yylhs.value.as < t_const_value* > () = yystack_[4].value.as < t_const_value* > ();
      yylhs.value.as < t_const_value* > ()->add_map(std::make_unique<t_const_value>(yystack_[2].value.as < std::string > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2231 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 78: // ConstStructContents: Identifier "=" ConstValue
#line 696 "parse/thrifty.yy"
    {
      driver.debug("ConstStructContents => Identifier = ConstValue");
      yylhs.value.as < t_const_value* > () = new t_const_value();
      yylhs.value.as < t_const_value* > ()->set_map();
      yylhs.value.as < t_const_value* > ()->add_map(std::make_unique<t_const_value>(yystack_[2].value.as < std::string > ()), own(yystack_[0].value.as < t_const_value* > ()));
    }
#line 2242 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 79: // Struct: tok_struct Identifier "{" FieldList "}"
#line 705 "parse/thrifty.yy"
    {
      driver.debug("Struct => tok_struct Identifier { FieldList }");
      yylhs.value.as < t_struct* > () = new t_struct(driver.program, std::move(yystack_[3].value.as < std::string > ()));
      driver.set_fields(*yylhs.value.as < t_struct* > (), std::move(*own(yystack_[1].value.as < t_field_list* > ())));
      yylhs.value.as < t_struct* > ()->set_lineno(yystack_[3].location.end.line);
    }
#line 2253 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 80: // Union: tok_union Identifier "{" FieldList "}"
#line 714 "parse/thrifty.yy"
    {
      driver.debug("Union => tok_union Identifier { FieldList }");
      yylhs.value.as < t_union* > () = new t_union(driver.program, std::move(yystack_[3].value.as < std::string > ()));
      driver.set_fields(*yylhs.value.as < t_union* > (), std::move(*own(yystack_[1].value.as < t_field_list* > ())));
      yylhs.value.as < t_union* > ()->set_lineno(yystack_[3].location.end.line);
    }
#line 2264 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 81: // Exception: ErrorSafety ErrorKind ErrorBlame tok_exception Identifier "{" FieldList "}"
#line 724 "parse/thrifty.yy"
    {
      driver.debug("Exception => ErrorSafety ErrorKind ErrorBlame tok_exception "
        "Identifier { FieldList }");
      // TODO(afuller): Correct resulting source_loc.begin when safety qualifier is omitted.
      yylhs.value.as < t_exception* > () = new t_exception(driver.program, std::move(yystack_[3].value.as < std::string > ()));
      yylhs.value.as < t_exception* > ()->set_safety(yystack_[7].value.as < t_error_safety > ());
      yylhs.value.as < t_exception* > ()->set_kind(yystack_[6].value.as < t_error_kind > ());
      yylhs.value.as < t_exception* > ()->set_blame(yystack_[5].value.as < t_error_blame > ());
      driver.set_fields(*yylhs.value.as < t_exception* > (), std::move(*own(yystack_[1].value.as < t_field_list* > ())));
      yylhs.value.as < t_exception* > ()->set_lineno(yystack_[3].location.end.line);
    }
#line 2280 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 82: // ErrorSafety: tok_safe
#line 737 "parse/thrifty.yy"
           { yylhs.value.as < t_error_safety > () = t_error_safety::safe;}
#line 2286 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 83: // ErrorSafety: %empty
#line 738 "parse/thrifty.yy"
           { yylhs.value.as < t_error_safety > () = {}; }
#line 2292 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 84: // ErrorKind: tok_transient
#line 741 "parse/thrifty.yy"
                { yylhs.value.as < t_error_kind > () = t_error_kind::transient; }
#line 2298 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 85: // ErrorKind: tok_stateful
#line 742 "parse/thrifty.yy"
                { yylhs.value.as < t_error_kind > () = t_error_kind::stateful; }
#line 2304 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 86: // ErrorKind: tok_permanent
#line 743 "parse/thrifty.yy"
                { yylhs.value.as < t_error_kind > () = t_error_kind::permanent; }
#line 2310 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 87: // ErrorKind: %empty
#line 744 "parse/thrifty.yy"
                { yylhs.value.as < t_error_kind > () = {}; }
#line 2316 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 88: // ErrorBlame: tok_client
#line 747 "parse/thrifty.yy"
             { yylhs.value.as < t_error_blame > () = t_error_blame::client; }
#line 2322 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 89: // ErrorBlame: tok_server
#line 748 "parse/thrifty.yy"
             { yylhs.value.as < t_error_blame > () = t_error_blame::server; }
#line 2328 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 90: // ErrorBlame: %empty
#line 749 "parse/thrifty.yy"
             { yylhs.value.as < t_error_blame > () = {}; }
#line 2334 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 91: // Service: tok_service Identifier Extends "{" FunctionList "}"
#line 753 "parse/thrifty.yy"
    {
      driver.debug("Service => tok_service Identifier Extends { FunctionList }");
      yylhs.value.as < t_service* > () = new t_service(driver.program, std::move(yystack_[4].value.as < std::string > ()), yystack_[3].value.as < t_ref<t_service> > ());
      driver.set_functions(*yylhs.value.as < t_service* > (), own(yystack_[1].value.as < t_function_list* > ()));
      yylhs.value.as < t_service* > ()->set_lineno(yystack_[4].location.end.line);
    }
#line 2345 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 92: // Extends: tok_extends Identifier
#line 762 "parse/thrifty.yy"
    {
      driver.debug("Extends -> tok_extends Identifier");
      yylhs.value.as < t_ref<t_service> > () = driver.find_service(yystack_[0].value.as < std::string > ());
    }
#line 2354 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 93: // Extends: %empty
#line 766 "parse/thrifty.yy"
    { yylhs.value.as < t_ref<t_service> > () = nullptr; }
#line 2360 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 94: // Interaction: tok_interaction Identifier "{" FunctionList "}"
#line 770 "parse/thrifty.yy"
    {
      driver.debug("Interaction -> tok_interaction Identifier { FunctionList }");
      yylhs.value.as < t_interaction* > () = new t_interaction(driver.program, std::move(yystack_[3].value.as < std::string > ()));
      driver.set_functions(*yylhs.value.as < t_interaction* > (), own(yystack_[1].value.as < t_function_list* > ()));
      yylhs.value.as < t_interaction* > ()->set_lineno(yystack_[3].location.end.line);
    }
#line 2371 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 95: // FunctionList: FunctionList FunctionAnnotated CommaOrSemicolonOptional
#line 779 "parse/thrifty.yy"
    {
      driver.debug("FunctionList -> FunctionList FunctionAnnotated CommaOrSemicolonOptional");
      yystack_[2].value.as < t_function_list* > ()->emplace_back(own(yystack_[1].value.as < t_function* > ()));
      yylhs.value.as < t_function_list* > () = yystack_[2].value.as < t_function_list* > ();
    }
#line 2381 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 96: // FunctionList: FunctionList Performs CommaOrSemicolon
#line 785 "parse/thrifty.yy"
    {
      driver.debug("FunctionList -> FunctionList Performs CommaOrSemicolon");
      yystack_[2].value.as < t_function_list* > ()->emplace_back(own(yystack_[1].value.as < t_function* > ()));
      yylhs.value.as < t_function_list* > () = yystack_[2].value.as < t_function_list* > ();
    }
#line 2391 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 97: // FunctionList: %empty
#line 791 "parse/thrifty.yy"
    {
      driver.debug("FunctionList -> ");
      yylhs.value.as < t_function_list* > () = new t_function_list;
    }
#line 2400 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 98: // Function: FunctionQualifier FunctionType Identifier "(" FieldList ")" MaybeThrows
#line 798 "parse/thrifty.yy"
    {
      driver.debug("Function => FunctionQualifier FunctionType Identifier ( FieldList ) MaybeThrows");
      driver.avoid_tokens_loc(
        yylhs.location,
        {{yystack_[6].value.as < t_function_qualifier > () == t_function_qualifier::unspecified, yystack_[5].location}},
        {{yystack_[0].value.as < t_throws* > () == nullptr, yystack_[1].location}});
      yylhs.value.as < t_function* > () = new t_function(driver.program, std::move(yystack_[5].value.as < std::pair<t_type_ref, boost::optional<t_type_ref>> > ().first), std::move(yystack_[4].value.as < std::string > ()));
      if (yystack_[5].value.as < std::pair<t_type_ref, boost::optional<t_type_ref>> > ().second) {
        yylhs.value.as < t_function* > ()->set_returned_interaction(std::move(*yystack_[5].value.as < std::pair<t_type_ref, boost::optional<t_type_ref>> > ().second));
      }
      yylhs.value.as < t_function* > ()->set_qualifier(yystack_[6].value.as < t_function_qualifier > ());
      driver.set_fields(yylhs.value.as < t_function* > ()->params(), std::move(*own(yystack_[2].value.as < t_field_list* > ())));
      yylhs.value.as < t_function* > ()->set_exceptions(own(yystack_[0].value.as < t_throws* > ()));
      yylhs.value.as < t_function* > ()->set_lineno(yystack_[4].location.end.line);
      // TODO(afuller): Leave the param list unnamed.
      yylhs.value.as < t_function* > ()->params().set_name(yylhs.value.as < t_function* > ()->name() + "_args");
    }
#line 2422 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 99: // FunctionAnnotated: StatementAttrs Function Annotations
#line 818 "parse/thrifty.yy"
    {
      driver.debug("FunctionAnnotated => StatementAttrs Function Annotations");
      driver.avoid_tokens_loc(yylhs.location, {{yystack_[2].value.as < t_def_attrs* > () == nullptr, yystack_[1].location}}, {{yystack_[0].value.as < t_annotations* > () == nullptr, yystack_[1].location}});
      yylhs.value.as < t_function* > () = yystack_[1].value.as < t_function* > ();
      driver.set_attributes(*yylhs.value.as < t_function* > (), own(yystack_[2].value.as < t_def_attrs* > ()), own(yystack_[0].value.as < t_annotations* > ()), yylhs.location);
    }
#line 2433 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 100: // Performs: tok_performs FieldType
#line 827 "parse/thrifty.yy"
    {
      driver.debug("Performs => tok_performs FieldType");
      auto& ret = yystack_[0].value.as < t_type_ref > ();
      std::string name = ret.get_type()
          ? "create" + ret.get_type()->get_name()
          : "<interaction placeholder>";
      yylhs.value.as < t_function* > () = new t_function(
        std::move(ret),
        std::move(name),
        std::make_unique<t_paramlist>(driver.program)
      );
      yylhs.value.as < t_function* > ()->set_lineno(driver.scanner->get_lineno());
      yylhs.value.as < t_function* > ()->set_is_interaction_constructor();
    }
#line 2452 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 101: // FunctionQualifier: tok_oneway
#line 843 "parse/thrifty.yy"
                 { yylhs.value.as < t_function_qualifier > () = t_function_qualifier::one_way; }
#line 2458 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 102: // FunctionQualifier: tok_idempotent
#line 844 "parse/thrifty.yy"
                 { yylhs.value.as < t_function_qualifier > () = t_function_qualifier::idempotent; }
#line 2464 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 103: // FunctionQualifier: tok_readonly
#line 845 "parse/thrifty.yy"
                 { yylhs.value.as < t_function_qualifier > () = t_function_qualifier::read_only; }
#line 2470 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 104: // FunctionQualifier: %empty
#line 846 "parse/thrifty.yy"
                 { yylhs.value.as < t_function_qualifier > () = {}; }
#line 2476 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 105: // MaybeThrows: tok_throws "(" FieldList ")"
#line 850 "parse/thrifty.yy"
    {
      driver.debug("MaybeThrows -> tok_throws ( FieldList )");
      yylhs.value.as < t_throws* > () = driver.new_throws(own(yystack_[1].value.as < t_field_list* > ())).release();
    }
#line 2485 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 106: // MaybeThrows: %empty
#line 854 "parse/thrifty.yy"
    { yylhs.value.as < t_throws* > () = nullptr; }
#line 2491 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 107: // FieldList: FieldList FieldAnnotated CommaOrSemicolonOptional InlineDocOptional
#line 858 "parse/thrifty.yy"
    {
      driver.debug("FieldList -> FieldAnnotated CommaOrSemicolonOptional");
      yylhs.value.as < t_field_list* > () = yystack_[3].value.as < t_field_list* > ();
      if (yystack_[0].value.as < t_doc > () != boost::none) {
        driver.set_doctext(*yystack_[2].value.as < t_field* > (), yystack_[0].value.as < t_doc > ());
      }
      yylhs.value.as < t_field_list* > ()->emplace_back(yystack_[2].value.as < t_field* > ());
    }
#line 2504 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 108: // FieldList: %empty
#line 867 "parse/thrifty.yy"
    {
      driver.debug("FieldList -> ");
      yylhs.value.as < t_field_list* > () = new t_field_list;
    }
#line 2513 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 109: // Field: FieldId FieldQualifier FieldType Identifier FieldValue
#line 874 "parse/thrifty.yy"
    {
      driver.debug("Field => FieldId FieldQualifier FieldType Identifier FieldValue");
      driver.avoid_tokens_loc(yylhs.location, {}, {{yystack_[0].value.as < t_const_value* > () == nullptr, yystack_[1].location}});
      yylhs.value.as < t_field* > () = new t_field(std::move(yystack_[2].value.as < t_type_ref > ()), std::move(yystack_[1].value.as < std::string > ()), yystack_[4].value.as < boost::optional<t_field_id> > ().value_or(0), yystack_[4].value.as < boost::optional<t_field_id> > () != boost::none);
      yylhs.value.as < t_field* > ()->set_qualifier(yystack_[3].value.as < t_field_qualifier > ());
      yylhs.value.as < t_field* > ()->set_default_value(own(yystack_[0].value.as < t_const_value* > ()));
      yylhs.value.as < t_field* > ()->set_lineno(yystack_[1].location.end.line);
    }
#line 2526 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 110: // FieldAnnotated: StatementAttrs Field Annotations
#line 885 "parse/thrifty.yy"
    {
      driver.debug("FieldAnnotated => StatementAttrs Field Annotations");
      driver.avoid_tokens_loc(yylhs.location, {{yystack_[2].value.as < t_def_attrs* > () == nullptr, yystack_[1].location}}, {{yystack_[0].value.as < t_annotations* > () == nullptr, yystack_[1].location}});
      yylhs.value.as < t_field* > () = yystack_[1].value.as < t_field* > ();
      driver.set_attributes(*yylhs.value.as < t_field* > (), own(yystack_[2].value.as < t_def_attrs* > ()), own(yystack_[0].value.as < t_annotations* > ()), yylhs.location);
    }
#line 2537 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 111: // FieldId: Integer ":"
#line 893 "parse/thrifty.yy"
              { yylhs.value.as < boost::optional<t_field_id> > () = driver.to_field_id(yystack_[1].value.as < int64_t > ()); }
#line 2543 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 112: // FieldId: %empty
#line 894 "parse/thrifty.yy"
              { yylhs.value.as < boost::optional<t_field_id> > () = boost::none; }
#line 2549 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 113: // FieldQualifier: tok_required
#line 897 "parse/thrifty.yy"
               { yylhs.value.as < t_field_qualifier > () = t_field_qualifier::required; }
#line 2555 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 114: // FieldQualifier: tok_optional
#line 898 "parse/thrifty.yy"
               { yylhs.value.as < t_field_qualifier > () = t_field_qualifier::optional; }
#line 2561 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 115: // FieldQualifier: %empty
#line 899 "parse/thrifty.yy"
               { yylhs.value.as < t_field_qualifier > () = {}; }
#line 2567 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 116: // FieldValue: "=" ConstValue
#line 903 "parse/thrifty.yy"
    {
      if (driver.mode == parsing_mode::PROGRAM) {
        yylhs.value.as < t_const_value* > () = yystack_[0].value.as < t_const_value* > ();
      } else {
        delete yystack_[0].value.as < t_const_value* > ();
        yylhs.value.as < t_const_value* > () = nullptr;
      }
    }
#line 2580 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 117: // FieldValue: %empty
#line 911 "parse/thrifty.yy"
    { yylhs.value.as < t_const_value* > () = nullptr; }
#line 2586 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 118: // FunctionType: StreamReturnType
#line 915 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> StreamReturnType");
      yylhs.value.as < std::pair<t_type_ref, boost::optional<t_type_ref>> > () = {driver.new_type_ref(own(yystack_[0].value.as < t_stream_response* > ()), nullptr), boost::none};
    }
#line 2595 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 119: // FunctionType: FieldType "," StreamReturnType
#line 920 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> FieldType, StreamReturnType");
      // This might actually be an interaction, corrected in standard mutator.
      yystack_[0].value.as < t_stream_response* > ()->set_first_response_type(std::move(yystack_[2].value.as < t_type_ref > ()));
      yylhs.value.as < std::pair<t_type_ref, boost::optional<t_type_ref>> > () = {driver.new_type_ref(own(yystack_[0].value.as < t_stream_response* > ()), nullptr), boost::none};
    }
#line 2606 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 120: // FunctionType: FieldType "," FieldType "," StreamReturnType
#line 927 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> FieldType, FieldType, StreamReturnType");
      yystack_[0].value.as < t_stream_response* > ()->set_first_response_type(std::move(yystack_[2].value.as < t_type_ref > ()));
      yylhs.value.as < std::pair<t_type_ref, boost::optional<t_type_ref>> > () = {driver.new_type_ref(own(yystack_[0].value.as < t_stream_response* > ()), nullptr), yystack_[4].value.as < t_type_ref > ()};
    }
#line 2616 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 121: // FunctionType: SinkReturnType
#line 933 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> SinkReturnType");
      yylhs.value.as < std::pair<t_type_ref, boost::optional<t_type_ref>> > () = {driver.new_type_ref(own(yystack_[0].value.as < t_sink* > ()), nullptr), boost::none};
    }
#line 2625 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 122: // FunctionType: FieldType "," SinkReturnType
#line 938 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> FieldType, SinkReturnType");
      // This might actually be an interaction, corrected in standard mutator.
      yystack_[0].value.as < t_sink* > ()->set_first_response_type(std::move(yystack_[2].value.as < t_type_ref > ()));
      yylhs.value.as < std::pair<t_type_ref, boost::optional<t_type_ref>> > () = {driver.new_type_ref(own(yystack_[0].value.as < t_sink* > ()), nullptr), boost::none};
    }
#line 2636 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 123: // FunctionType: FieldType "," FieldType "," SinkReturnType
#line 945 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> FieldType, FieldType, SinkReturnType");
      yystack_[0].value.as < t_sink* > ()->set_first_response_type(std::move(yystack_[2].value.as < t_type_ref > ()));
      yylhs.value.as < std::pair<t_type_ref, boost::optional<t_type_ref>> > () = {driver.new_type_ref(own(yystack_[0].value.as < t_sink* > ()), nullptr), yystack_[4].value.as < t_type_ref > ()};
    }
#line 2646 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 124: // FunctionType: FieldType
#line 951 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> FieldType");
      // This might actually be an interaction, corrected in standard mutator.
      yylhs.value.as < std::pair<t_type_ref, boost::optional<t_type_ref>> > () = {yystack_[0].value.as < t_type_ref > (), boost::none};
    }
#line 2656 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 125: // FunctionType: FieldType "," FieldType
#line 957 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> FieldType, FieldType");
      yylhs.value.as < std::pair<t_type_ref, boost::optional<t_type_ref>> > () = {yystack_[0].value.as < t_type_ref > (), yystack_[2].value.as < t_type_ref > ()};
    }
#line 2665 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 126: // FunctionType: tok_void
#line 962 "parse/thrifty.yy"
    {
      driver.debug("FunctionType -> tok_void");
      yylhs.value.as < std::pair<t_type_ref, boost::optional<t_type_ref>> > () = {t_base_type::t_void(), boost::none};
    }
#line 2674 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 127: // StreamReturnType: tok_stream "<" FieldType MaybeThrows ">"
#line 969 "parse/thrifty.yy"
  {
    driver.debug("StreamReturnType -> tok_stream < FieldType MaybeThrows >");
    auto stream_res = std::make_unique<t_stream_response>(std::move(yystack_[2].value.as < t_type_ref > ()));
    stream_res->set_exceptions(own(yystack_[1].value.as < t_throws* > ()));
    yylhs.value.as < t_stream_response* > () = stream_res.release();
  }
#line 2685 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 128: // SinkReturnType: tok_sink "<" SinkFieldType "," SinkFieldType ">"
#line 978 "parse/thrifty.yy"
    {
      driver.debug("SinkReturnType -> tok_sink<FieldType, FieldType>");
      auto sink = std::make_unique<t_sink>(std::move(yystack_[3].value.as < t_typethrowspair > ().first), std::move(yystack_[1].value.as < t_typethrowspair > ().first));
      sink->set_sink_exceptions(own(yystack_[3].value.as < t_typethrowspair > ().second));
      sink->set_final_response_exceptions(own(yystack_[1].value.as < t_typethrowspair > ().second));
      yylhs.value.as < t_sink* > () = sink.release();
    }
#line 2697 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 129: // SinkFieldType: FieldType MaybeThrows
#line 988 "parse/thrifty.yy"
    {
      driver.debug("SinkFieldType => FieldType MaybeThrows");
      yylhs.value.as < t_typethrowspair > () = std::make_pair(yystack_[1].value.as < t_type_ref > (), yystack_[0].value.as < t_throws* > ());
    }
#line 2706 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 130: // FieldType: FieldTypeIdentifier Annotations
#line 995 "parse/thrifty.yy"
    {
      driver.debug("FieldType => Identifier Annotations");
      yylhs.value.as < t_type_ref > () = driver.new_type_ref(std::move(yystack_[1].value.as < std::string > ()), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 2715 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 131: // FieldType: BaseType Annotations
#line 1000 "parse/thrifty.yy"
    {
      driver.debug("FieldType -> BaseType");
      yylhs.value.as < t_type_ref > () = driver.new_type_ref(*yystack_[1].value.as < t_ref<t_base_type> > (), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 2724 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 132: // FieldType: ContainerType Annotations
#line 1005 "parse/thrifty.yy"
    {
      driver.debug("FieldType -> ContainerType");
      yylhs.value.as < t_type_ref > () = driver.new_type_ref(own(yystack_[1].value.as < t_container* > ()), own(yystack_[0].value.as < t_annotations* > ()));
    }
#line 2733 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 133: // BaseType: tok_string
#line 1012 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_string");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_string();
    }
#line 2742 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 134: // BaseType: tok_binary
#line 1017 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_binary");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_binary();
    }
#line 2751 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 135: // BaseType: tok_bool
#line 1022 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_bool");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_bool();
    }
#line 2760 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 136: // BaseType: tok_byte
#line 1027 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_byte");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_byte();
    }
#line 2769 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 137: // BaseType: tok_i16
#line 1032 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i16");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_i16();
    }
#line 2778 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 138: // BaseType: tok_i32
#line 1037 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i32");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_i32();
    }
#line 2787 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 139: // BaseType: tok_i64
#line 1042 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_i64");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_i64();
    }
#line 2796 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 140: // BaseType: tok_double
#line 1047 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_double");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_double();
    }
#line 2805 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 141: // BaseType: tok_float
#line 1052 "parse/thrifty.yy"
    {
      driver.debug("BaseType -> tok_float");
      yylhs.value.as < t_ref<t_base_type> > () = &t_base_type::t_float();
    }
#line 2814 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 142: // ContainerType: MapType
#line 1058 "parse/thrifty.yy"
           { yylhs.value.as < t_container* > () = yystack_[0].value.as < t_container* > (); }
#line 2820 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 143: // ContainerType: SetType
#line 1059 "parse/thrifty.yy"
           { yylhs.value.as < t_container* > () = yystack_[0].value.as < t_container* > (); }
#line 2826 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 144: // ContainerType: ListType
#line 1060 "parse/thrifty.yy"
           { yylhs.value.as < t_container* > () = yystack_[0].value.as < t_container* > (); }
#line 2832 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 145: // MapType: tok_map "<" FieldType "," FieldType ">"
#line 1064 "parse/thrifty.yy"
    {
      driver.debug("MapType -> tok_map<FieldType, FieldType>");
      yylhs.value.as < t_container* > () = new t_map(std::move(yystack_[3].value.as < t_type_ref > ()), std::move(yystack_[1].value.as < t_type_ref > ()));
    }
#line 2841 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 146: // SetType: tok_set "<" FieldType ">"
#line 1071 "parse/thrifty.yy"
    {
      driver.debug("SetType -> tok_set<FieldType>");
      yylhs.value.as < t_container* > () = new t_set(std::move(yystack_[1].value.as < t_type_ref > ()));
    }
#line 2850 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 147: // ListType: tok_list "<" FieldType ">"
#line 1078 "parse/thrifty.yy"
    {
      driver.debug("ListType -> tok_list<FieldType>");
      yylhs.value.as < t_container* > () = new t_list(std::move(yystack_[1].value.as < t_type_ref > ()));
    }
#line 2859 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 148: // Annotations: "(" AnnotationList CommaOrSemicolonOptional ")"
#line 1085 "parse/thrifty.yy"
    {
      driver.debug("Annotations => ( AnnotationList CommaOrSemicolonOptional)");
      yylhs.value.as < t_annotations* > () = yystack_[2].value.as < t_annotations* > ();
    }
#line 2868 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 149: // Annotations: "(" ")"
#line 1090 "parse/thrifty.yy"
    {
      driver.debug("Annotations => ( )");
      yylhs.value.as < t_annotations* > () = nullptr;
    }
#line 2877 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 150: // Annotations: %empty
#line 1094 "parse/thrifty.yy"
    { yylhs.value.as < t_annotations* > () = nullptr; }
#line 2883 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 151: // AnnotationList: AnnotationList CommaOrSemicolon Annotation
#line 1098 "parse/thrifty.yy"
    {
      driver.debug("NodeAnnotationList => NodeAnnotationList CommaOrSemicolon Annotation");
      yylhs.value.as < t_annotations* > () = yystack_[2].value.as < t_annotations* > ();
      yylhs.value.as < t_annotations* > ()->strings[yystack_[0].value.as < t_annotation* > ()->first] = std::move(yystack_[0].value.as < t_annotation* > ()->second);
      delete yystack_[0].value.as < t_annotation* > ();
    }
#line 2894 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 152: // AnnotationList: Annotation
#line 1105 "parse/thrifty.yy"
    {
      driver.debug("AnnotationList => Annotation");
      /* Just use a dummy structure to hold the annotations. */
      yylhs.value.as < t_annotations* > () = new t_annotations();
      yylhs.value.as < t_annotations* > ()->strings[yystack_[0].value.as < t_annotation* > ()->first] = std::move(yystack_[0].value.as < t_annotation* > ()->second);
      delete yystack_[0].value.as < t_annotation* > ();
    }
#line 2906 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 153: // Annotation: Identifier "=" IntOrLiteral
#line 1115 "parse/thrifty.yy"
    {
      driver.debug("Annotation -> Identifier = IntOrLiteral");
      yylhs.value.as < t_annotation* > () = new t_annotation{yystack_[2].value.as < std::string > (), {driver.get_source_range(yylhs.location), yystack_[0].value.as < std::string > ()}};
    }
#line 2915 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 154: // Annotation: Identifier
#line 1120 "parse/thrifty.yy"
    {
      driver.debug("Annotation -> Identifier");
      yylhs.value.as < t_annotation* > () = new t_annotation{yystack_[0].value.as < std::string > (), {driver.get_source_range(yylhs.location), "1"}};
    }
#line 2924 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 155: // StructuredAnnotations: NonEmptyStructuredAnnotationList
#line 1127 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotations -> NonEmptyStructuredAnnotationList");
      yylhs.value.as < t_struct_annotations* > () = yystack_[0].value.as < t_struct_annotations* > ();
    }
#line 2933 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 156: // StructuredAnnotations: %empty
#line 1131 "parse/thrifty.yy"
    { yylhs.value.as < t_struct_annotations* > () = nullptr; }
#line 2939 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 157: // NonEmptyStructuredAnnotationList: NonEmptyStructuredAnnotationList StructuredAnnotation
#line 1135 "parse/thrifty.yy"
    {
      driver.debug("NonEmptyStructuredAnnotationList -> NonEmptyStructuredAnnotationList StructuredAnnotation");
      yylhs.value.as < t_struct_annotations* > () = yystack_[1].value.as < t_struct_annotations* > ();
      yylhs.value.as < t_struct_annotations* > ()->emplace_back(yystack_[0].value.as < t_const* > ());
    }
#line 2949 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 158: // NonEmptyStructuredAnnotationList: StructuredAnnotation
#line 1141 "parse/thrifty.yy"
    {
      driver.debug("NonEmptyStructuredAnnotationList ->");
      yylhs.value.as < t_struct_annotations* > () = new t_struct_annotations;
      yylhs.value.as < t_struct_annotations* > ()->emplace_back(yystack_[0].value.as < t_const* > ());
    }
#line 2959 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 159: // StructuredAnnotation: "@" ConstStruct
#line 1149 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotation => @ConstStruct");
      yylhs.value.as < t_const* > () = driver.new_struct_annotation(own(yystack_[0].value.as < t_const_value* > ())).release();
    }
#line 2968 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 160: // StructuredAnnotation: "@" ConstStructType
#line 1154 "parse/thrifty.yy"
    {
      driver.debug("StructuredAnnotation => @ConstStructType");
      auto value = std::make_unique<t_const_value>();
      value->set_map();
      value->set_ttype(std::move(yystack_[0].value.as < t_type_ref > ()));
      yylhs.value.as < t_const* > () = driver.new_struct_annotation(std::move(value)).release();
    }
#line 2980 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 161: // IntOrLiteral: tok_literal
#line 1164 "parse/thrifty.yy"
    {
      driver.debug("IntOrLiteral -> tok_literal");
      yylhs.value.as < std::string > () = yystack_[0].value.as < std::string > ();
    }
#line 2989 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 162: // IntOrLiteral: tok_bool_constant
#line 1169 "parse/thrifty.yy"
    {
      char buf[21];  // max len of int64_t as string + null terminator
      driver.debug("IntOrLiteral -> tok_bool_constant");
      sprintf(buf, "%" PRIi32, yystack_[0].value.as < bool > () ? 1 : 0);
      yylhs.value.as < std::string > () = buf;
    }
#line 3000 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;

  case 163: // IntOrLiteral: Integer
#line 1176 "parse/thrifty.yy"
    {
      char buf[21];  // max len of int64_t as string + null terminator
      driver.debug("IntOrLiteral -> Integer");
      sprintf(buf, "%" PRIi64, yystack_[0].value.as < int64_t > ());
      yylhs.value.as < std::string > () = buf;
    }
#line 3011 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"
    break;


#line 3015 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        std::string msg = YY_("syntax error");
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

#if YYDEBUG || 0
  const char *
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytname_[yysymbol];
  }
#endif // #if YYDEBUG || 0





  const short parser::yypact_ninf_ = -241;

  const signed char parser::yytable_ninf_ = -77;

  const short
  parser::yypact_[] =
  {
    -241,    18,    23,  -241,     5,    96,   342,   271,  -241,     5,
    -241,  -241,  -241,  -241,  -241,  -241,   377,   271,   271,   271,
     377,   271,   271,    70,  -241,    11,  -241,  -241,  -241,  -241,
    -241,  -241,     8,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
      19,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
    -241,    16,    35,    42,    11,   271,    11,    11,  -241,  -241,
    -241,    53,    20,    75,   271,    77,    79,    89,   100,   105,
     110,   271,  -241,   113,  -241,  -241,  -241,  -241,    65,   298,
     377,   377,   377,  -241,  -241,  -241,  -241,  -241,   271,    88,
    -241,   107,  -241,  -241,  -241,  -241,  -241,  -241,   220,  -241,
     112,    96,  -241,  -241,  -241,    73,  -241,   126,    96,   135,
     125,   127,   134,  -241,  -241,   138,   285,   141,   -10,  -241,
    -241,    59,   271,   137,   271,   285,   271,   157,   377,  -241,
    -241,  -241,    46,    96,    -5,  -241,   271,    96,  -241,  -241,
    -241,  -241,   165,   234,   111,   115,   159,  -241,  -241,  -241,
    -241,  -241,  -241,    19,  -241,  -241,   377,    26,    96,    96,
    -241,  -241,   167,   168,  -241,  -241,  -241,  -241,   169,  -241,
     170,  -241,   158,   166,    11,    71,   176,  -241,   171,    11,
     176,  -241,   174,    96,  -241,  -241,    96,  -241,  -241,  -241,
    -241,  -241,  -241,  -241,  -241,    11,     9,  -241,  -241,  -241,
     285,  -241,  -241,  -241,  -241,  -241,   377,  -241,  -241,    46,
    -241,  -241,   285,   285,   173,   285,   178,  -241,  -241,   172,
     177,   271,  -241,  -241,   186,   185,  -241,   271,  -241,  -241,
     182,  -241,  -241,  -241,   377,   377,   183,   322,  -241,   188,
     285,   130,   193,   130,  -241,  -241,  -241,   194,   285,  -241,
    -241,   189,   187,   377,  -241,   200,    99,  -241,  -241,  -241,
     199,   130,  -241,  -241,   202,  -241,  -241,  -241
  };

  const unsigned char
  parser::yydefact_[] =
  {
      43,     0,    20,     1,   156,    19,    83,     0,    41,   155,
     158,    16,    17,    18,    42,    82,     0,     0,     0,     0,
       0,     0,     0,     0,    39,   150,    30,    31,    32,    33,
      34,    35,    87,    36,    37,     3,     5,     6,     7,     9,
       8,    10,    11,    12,    13,    14,    15,     4,    76,   159,
     160,   157,   135,   136,   133,   134,   137,   138,   139,   140,
     141,     0,     0,     0,   150,     0,   150,   150,   142,   143,
     144,     0,    93,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    38,     0,    40,    84,    85,    86,    90,     0,
       0,     0,     0,   130,    50,   131,   132,   108,     0,     0,
      53,     0,   108,    97,    24,    28,    29,    25,     0,   149,
     154,    19,   152,    89,    88,     0,    75,     0,    19,     0,
       0,     0,    20,    92,    97,    20,     0,    20,    20,    27,
      26,     0,    18,     0,     0,     0,    18,     0,     0,   147,
     146,    79,   112,    19,    20,    51,     0,    19,    61,    58,
      44,    47,     0,     0,     0,     0,    62,    59,    60,    57,
      63,    64,    65,     0,    80,    94,     0,   104,    19,     0,
     161,   162,     0,     0,   163,   153,   151,   148,     0,    78,
       0,    74,     0,     0,   150,   115,    23,    91,    56,   150,
      23,    71,     0,    19,    67,    69,    19,    45,    48,    46,
      49,   100,   101,   102,   103,   150,     0,    95,    96,   108,
       0,   145,   111,   110,   113,   114,     0,    22,   107,     0,
      54,    52,     0,    18,     0,    18,     0,    99,   126,     0,
       0,     0,   118,   121,   124,    20,    77,     0,    55,    73,
       0,    70,    68,    66,     0,     0,     0,     0,    81,   117,
       0,   106,     0,   106,   108,   119,   122,   125,     0,   109,
      72,     0,     0,     0,   129,    20,     0,   116,   108,   127,
       0,   106,   120,   123,    20,   128,    98,   105
  };

  const short
  parser::yypgoto_[] =
  {
    -241,  -241,   -16,     3,   -81,   -83,  -241,  -241,    32,  -241,
    -241,  -241,  -241,     0,  -241,  -125,  -241,  -241,  -241,  -241,
    -241,  -241,  -241,  -120,  -241,  -241,  -241,  -241,   218,   219,
    -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,  -241,
      82,  -241,  -241,  -241,  -241,  -237,  -101,  -241,  -241,  -241,
    -241,  -241,  -241,  -240,  -228,   -36,   -11,  -241,  -241,  -241,
    -241,  -241,   -53,  -241,    98,  -241,  -241,   223,  -241
  };

  const short
  parser::yydefgoto_[] =
  {
       0,     1,    47,   156,    13,    14,     4,    23,   218,    82,
      24,    25,     5,   142,     2,   157,   158,    26,    27,   125,
     147,   189,    28,   159,   160,   196,   161,   193,   162,   163,
     118,    29,    30,    31,    32,    88,   115,    33,    99,    34,
     128,   205,   168,   169,   206,   262,   122,   184,   143,   185,
     216,   259,   231,   232,   233,   252,   253,    66,    67,    68,
      69,    70,    84,   111,   112,     8,     9,    10,   175
  };

  const short
  parser::yytable_[] =
  {
      64,   127,     6,   165,    64,    65,   174,   255,   187,    74,
      48,    93,    35,    95,    96,   179,   264,   183,     3,   256,
      71,    72,    73,    -2,    75,    76,   272,     7,   133,    83,
     132,    89,   192,   195,   276,   137,    90,   136,   273,   228,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,   229,   230,   150,    91,   166,    85,    86,    87,
     186,   166,    92,   170,   190,    97,   171,   150,    94,   172,
     173,   202,   203,   204,    64,    64,    64,   101,    98,   119,
     120,   121,   172,   173,   108,   207,   110,   100,   208,   102,
     236,   103,   117,   104,   238,    77,    78,    79,    80,    81,
     124,   123,   239,   240,   105,   242,    11,    12,   235,   106,
     224,   130,   223,   226,   107,   225,    35,   113,   114,   197,
     198,   126,    64,   199,   200,   146,   131,   182,   167,   134,
     260,   213,   109,   214,   215,   110,   220,   178,   267,   180,
     135,    36,   229,   230,   167,   138,   139,   141,   140,   188,
      64,   145,   227,   265,   164,   201,   177,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,   274,    35,   148,
     181,   -76,   149,   150,   151,   197,   199,   152,   191,   211,
     153,   209,   217,   212,   210,   219,   241,   261,   154,   155,
      64,   222,   244,    36,   243,   234,   247,   245,   248,   250,
      64,   254,   258,   263,   266,   237,   144,   268,   269,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,   271,
     275,   277,   221,    35,   129,    49,    50,   270,    64,    64,
     176,    64,    51,   251,   246,     0,   257,    35,   148,     0,
     249,   149,   150,   151,     0,     0,   152,    64,    36,   153,
     194,     0,     0,     0,     0,     0,     0,   154,   155,     0,
       0,     0,    36,     0,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    35,     0,     0,     0,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    35,   148,
       0,     0,   149,   150,   151,     0,     0,   152,     0,    36,
     153,    35,     0,     0,     0,     0,     0,     0,   154,   155,
       0,   116,     0,    36,     0,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    35,    36,     0,     0,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,     0,
       0,     0,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,     0,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,   229,   230,   -21,   -21,   -21,
     -21,   -21,     0,     0,     0,     0,     0,     0,     0,     0,
      35,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      15,     0,     0,     0,     0,     0,    16,    17,     0,     0,
       0,    18,    19,    20,     0,     0,    21,    22,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63
  };

  const short
  parser::yycheck_[] =
  {
      16,   102,     2,    13,    20,    16,   131,   247,    13,    20,
       7,    64,     3,    66,    67,   135,   253,   142,     0,   247,
      17,    18,    19,     0,    21,    22,   266,    22,   111,    18,
     111,    12,   152,   153,   271,   118,    20,   118,   266,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,     8,    20,    66,    49,    50,    51,
     143,    66,    20,     4,   147,    12,     7,     8,    65,    23,
      24,    45,    46,    47,    90,    91,    92,    74,    58,    90,
      91,    92,    23,    24,    81,   168,    83,    12,   169,    12,
     210,    12,    89,     4,   219,    25,    26,    27,    28,    29,
      12,    98,   222,   223,     4,   225,    10,    11,   209,     4,
     193,   108,   193,   196,     4,   196,     3,    52,    53,     8,
       9,    14,   138,     8,     9,   125,    14,   138,   128,    56,
     250,   184,    19,    62,    63,   132,   189,   134,   258,   136,
      14,    28,    43,    44,   144,    10,    21,    13,    21,   146,
     166,    13,   205,   254,    13,   166,    19,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,   268,     3,     4,
      13,    12,     7,     8,     9,     8,     8,    12,    13,    21,
      15,    12,     6,    17,    14,    14,    13,    57,    23,    24,
     206,    17,    20,    28,    16,   206,    10,    20,    13,    17,
     216,    18,    14,    10,    10,   216,   124,    18,    21,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    19,
      21,    19,   190,     3,     4,     7,     7,   263,   244,   245,
     132,   247,     9,   244,   231,    -1,   247,     3,     4,    -1,
     237,     7,     8,     9,    -1,    -1,    12,   263,    28,    15,
      16,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,    -1,
      -1,    -1,    28,    -1,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,     3,    -1,    -1,    -1,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,     3,     4,
      -1,    -1,     7,     8,     9,    -1,    -1,    12,    -1,    28,
      15,     3,    -1,    -1,    -1,    -1,    -1,    -1,    23,    24,
      -1,    13,    -1,    28,    -1,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,     3,    28,    -1,    -1,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    -1,
      -1,    -1,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    -1,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    25,    26,    27,
      28,    29,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
       3,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      48,    -1,    -1,    -1,    -1,    -1,    54,    55,    -1,    -1,
      -1,    59,    60,    61,    -1,    -1,    64,    65,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42
  };

  const unsigned char
  parser::yystos_[] =
  {
       0,    68,    81,     0,    73,    79,    80,    22,   132,   133,
     134,    10,    11,    71,    72,    48,    54,    55,    59,    60,
      61,    64,    65,    74,    77,    78,    84,    85,    89,    98,
      99,   100,   101,   104,   106,     3,    28,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    69,    70,    95,
      96,   134,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    69,   123,   124,   125,   126,   127,
     128,    70,    70,    70,   123,    70,    70,    25,    26,    27,
      28,    29,    76,    18,   129,    49,    50,    51,   102,    12,
      20,    20,    20,   129,    70,   129,   129,    12,    58,   105,
      12,    70,    12,    12,     4,     4,     4,     4,    70,    19,
      70,   130,   131,    52,    53,   103,    13,    70,    97,   123,
     123,   123,   113,    70,    12,    86,    14,   113,   107,     4,
      70,    14,    71,    72,    56,    14,    71,    72,    10,    21,
      21,    13,    80,   115,   107,    13,    80,    87,     4,     7,
       8,     9,    12,    15,    23,    24,    70,    82,    83,    90,
      91,    93,    95,    96,    13,    13,    66,    80,   109,   110,
       4,     7,    23,    24,    82,   135,   131,    19,    70,    90,
      70,    13,   123,    82,   114,   116,    72,    13,    70,    88,
      72,    13,    90,    94,    16,    90,    92,     8,     9,     8,
       9,   123,    45,    46,    47,   108,   111,    72,    71,    12,
      14,    21,    17,   129,    62,    63,   117,     6,    75,    14,
     129,    75,    17,    71,    72,    71,    72,   129,    30,    43,
      44,   119,   120,   121,   123,   113,    90,   123,    82,    90,
      90,    13,    90,    16,    20,    20,    70,    10,    13,    70,
      17,   123,   122,   123,    18,   120,   121,   123,    14,   118,
      90,    57,   112,    10,   112,   113,    10,    90,    18,    21,
     122,    19,   120,   121,   113,    21,   112,    19
  };

  const unsigned char
  parser::yyr1_[] =
  {
       0,    67,    68,    69,    70,    70,    70,    70,    70,    70,
      70,    70,    70,    70,    70,    70,    71,    71,    72,    72,
      73,    74,    75,    75,    76,    76,    76,    76,    76,    76,
      77,    77,    77,    77,    77,    77,    77,    77,    78,    78,
      79,    80,    81,    81,    82,    82,    82,    83,    83,    83,
      84,    85,    86,    86,    87,    88,    88,    89,    90,    90,
      90,    90,    90,    90,    90,    90,    91,    91,    92,    92,
      93,    93,    94,    94,    95,    95,    96,    97,    97,    98,
      99,   100,   101,   101,   102,   102,   102,   102,   103,   103,
     103,   104,   105,   105,   106,   107,   107,   107,   108,   109,
     110,   111,   111,   111,   111,   112,   112,   113,   113,   114,
     115,   116,   116,   117,   117,   117,   118,   118,   119,   119,
     119,   119,   119,   119,   119,   119,   119,   120,   121,   122,
     123,   123,   123,   124,   124,   124,   124,   124,   124,   124,
     124,   124,   125,   125,   125,   126,   127,   128,   129,   129,
     129,   130,   130,   131,   131,   132,   132,   133,   133,   134,
     134,   135,   135,   135
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     0,
       0,     0,     1,     0,     2,     2,     3,     3,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     1,
       3,     2,     3,     0,     1,     2,     2,     1,     2,     2,
       3,     5,     4,     0,     3,     3,     1,     5,     1,     1,
       1,     1,     1,     1,     1,     1,     4,     2,     3,     1,
       4,     2,     5,     3,     5,     3,     1,     5,     3,     5,
       5,     8,     1,     0,     1,     1,     1,     0,     1,     1,
       0,     6,     2,     0,     5,     3,     3,     0,     7,     3,
       2,     1,     1,     1,     0,     4,     0,     4,     0,     5,
       3,     2,     0,     1,     1,     0,     2,     0,     1,     3,
       5,     1,     3,     5,     1,     3,     1,     5,     6,     2,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     6,     4,     4,     4,     2,
       0,     3,     1,     3,     1,     1,     0,     2,     1,     2,
       2,     1,     1,     1
  };


#if YYDEBUG
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "tok_eof", "error", "\"invalid token\"", "tok_identifier",
  "tok_literal", "tok_doctext", "tok_inline_doc", "tok_bool_constant",
  "tok_int_constant", "tok_dub_constant", "\",\"", "\";\"", "\"{\"",
  "\"}\"", "\"=\"", "\"[\"", "\"]\"", "\":\"", "\"(\"", "\")\"", "\"<\"",
  "\">\"", "\"@\"", "\"+\"", "\"-\"", "tok_include", "tok_cpp_include",
  "tok_hs_include", "tok_package", "tok_namespace", "tok_void", "tok_bool",
  "tok_byte", "tok_string", "tok_binary", "tok_i16", "tok_i32", "tok_i64",
  "tok_double", "tok_float", "tok_map", "tok_list", "tok_set",
  "tok_stream", "tok_sink", "tok_oneway", "tok_idempotent", "tok_readonly",
  "tok_safe", "tok_transient", "tok_stateful", "tok_permanent",
  "tok_server", "tok_client", "tok_typedef", "tok_struct", "tok_exception",
  "tok_throws", "tok_extends", "tok_service", "tok_enum", "tok_const",
  "tok_required", "tok_optional", "tok_union", "tok_interaction",
  "tok_performs", "$accept", "Program", "FieldTypeIdentifier",
  "Identifier", "CommaOrSemicolon", "CommaOrSemicolonOptional",
  "CaptureDocText", "ProgramDocText", "InlineDocOptional", "Header",
  "Definition", "Statement", "StatementAnnotated", "StatementAttrs",
  "StatementList", "Integer", "Double", "Typedef", "Enum", "EnumValueList",
  "EnumValueAnnotated", "EnumValue", "Const", "ConstValue", "ConstList",
  "ConstListContents", "ConstMap", "ConstMapContents", "ConstStruct",
  "ConstStructType", "ConstStructContents", "Struct", "Union", "Exception",
  "ErrorSafety", "ErrorKind", "ErrorBlame", "Service", "Extends",
  "Interaction", "FunctionList", "Function", "FunctionAnnotated",
  "Performs", "FunctionQualifier", "MaybeThrows", "FieldList", "Field",
  "FieldAnnotated", "FieldId", "FieldQualifier", "FieldValue",
  "FunctionType", "StreamReturnType", "SinkReturnType", "SinkFieldType",
  "FieldType", "BaseType", "ContainerType", "MapType", "SetType",
  "ListType", "Annotations", "AnnotationList", "Annotation",
  "StructuredAnnotations", "NonEmptyStructuredAnnotationList",
  "StructuredAnnotation", "IntOrLiteral", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,   305,   305,   320,   323,   325,   326,   327,   328,   329,
     330,   331,   332,   333,   334,   335,   338,   339,   342,   343,
     345,   347,   353,   359,   362,   368,   374,   382,   390,   398,
     406,   407,   408,   409,   410,   411,   412,   413,   416,   422,
     430,   444,   455,   463,   468,   473,   478,   485,   490,   495,
     502,   510,   519,   529,   535,   544,   551,   559,   567,   573,
     578,   584,   589,   594,   599,   604,   611,   616,   624,   630,
     639,   644,   652,   658,   667,   673,   682,   689,   695,   704,
     713,   723,   737,   738,   741,   742,   743,   744,   747,   748,
     749,   752,   761,   766,   769,   778,   784,   791,   797,   817,
     826,   843,   844,   845,   846,   849,   854,   857,   867,   873,
     884,   893,   894,   897,   898,   899,   902,   911,   914,   919,
     926,   932,   937,   944,   950,   956,   961,   968,   977,   987,
     994,   999,  1004,  1011,  1016,  1021,  1026,  1031,  1036,  1041,
    1046,  1051,  1058,  1059,  1060,  1063,  1070,  1077,  1084,  1089,
    1094,  1097,  1104,  1114,  1119,  1126,  1131,  1134,  1140,  1148,
    1153,  1163,  1168,  1175
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


#line 95 "parse/thrifty.yy"
} } } } // apache::thrift::compiler::yy
#line 3563 "/builddir/build/BUILD/fbthrift-2022.03.14.00/redhat-linux-build/thrift/compiler/thrifty.cc"

#line 1183 "parse/thrifty.yy"


/**
 * Method that will be called by the generated parser upon errors.
 */
void apache::thrift::compiler::yy::parser::error(const location_type&, std::string const& message) {
  /*
   * TODO(urielrivas): Pass the location as argument to yyerror.
   */
  driver.yyerror(message);
}
